Declare @MyTable Table ([Date] date, [Group] int);

Insert into @MyTable
Select '2012-05-31', 1 Union All
Select '2012-05-30', Null Union All
Select '2012-05-29', Null Union All
Select '2012-05-28', 1 Union All
Select '2012-05-27', Null Union All
Select '2012-05-26', 1 Union All
Select '2012-05-25', Null Union All
Select '2012-05-24', Null Union All
Select '2012-05-23', Null Union All
Select '2012-05-22', 1 Union All
Select '2012-05-21', Null Union All
Select '2012-05-20', Null Union All
Select '2012-05-19', Null Union All
Select '2012-05-18', 1 Union All
Select '2012-05-17', Null Union All
Select '2012-05-16', Null Union All
Select '2012-05-15', Null Union All
Select '2012-05-14', Null Union All
Select '2012-05-13', Null Union All
Select '2012-05-12', 1 Union All
Select '2012-05-11', Null Union All
Select '2012-05-10', Null;

SELECT		[Date]
			, COUNT([Group]) OVER (ORDER BY [Date] DESC Rows Unbounded Preceding) AS [Group]
FROM		@MyTable
ORDER BY	[Date] DESC;