/***************************************
http://social.msdn.microsoft.com/Forums/en-US/transactsql/thread/4b3240b3-8b30-4736-a425-2d113845f81a
***************************************/

Use [TechEdNZ2012]
Go

Select * 
From EmployAttendence
Order By EmpID, WorkingDate

----Solution Starts here

;With DateGrouping
As
(
Select EmpID, WorkingDate, Status
		, DATEADD(	Day
					, -1 * ROW_NUMBER() Over(Partition By EmpID Order by WorkingDate)
					, WorkingDate
				) As DateGroup
From	EmployAttendence
Where	Status in ('A', 'W', 'H')
)

Select	EmpID, Min(WorkingDate) As AbsentStart, MAX(WorkingDate) As AbsentEnd, COUNT(*) As AbsentCount
From	DateGrouping
Where	Status = 'A'
Group By EmpId, DateGroup			
Having COUNT(*) > 1
Order by EmpID, AbsentStart