/***************************************
http://social.msdn.microsoft.com/Forums/en-US/transactsql/thread/2a0e628e-7c41-4efa-991f-d815a78effb2
C:\Users\steven\Documents\Find a Window of days between dates on different rows of data.htm
***************************************/

DECLARE @MyTable TABLE	(
							ItemRef			VARCHAR(10),
							LoanedOut		DATE,
							DueForReturn	DATE,
							DaysOnLoan As DateDiff(Day, LoanedOut, DueForReturn)
						);

INSERT INTO @MyTable 
VALUES
('Item1', '2012-09-06', '2012-09-07')
, ('Item2', '2012-09-08', '2012-09-15')
, ('Item1', '2012-09-09', '2012-09-15')
, ('Item2', '2012-09-20', '2012-09-22')
, ('Item1', '2012-09-16', '2012-09-18')
, ('Item2', '2012-09-25', '2012-09-27');

--Select * From @MyTable;

Select	ItemRef, DueForReturn As DateForLoan
		, Lead(LoanedOut, 1, '2999-12-31') Over(Partition By ItemRef Order By LoanedOut) As DateMustReturn
		, DateDiff(	Day
					, DueForReturn
					, Lead(LoanedOut, 1, '2999-12-31') Over(Partition By ItemRef Order By LoanedOut)
				) As AvailableDay
From	@MyTable;







--Select	ItemRef, LoanedOut, DueForReturn
--		, DateDiff(	Day
--					, Lag(DueForReturn, 1, DateAdd(Day, -1, LoanedOut) )
--						Over(Partition By ItemRef Order By LoanedOut) 
--					, LoanedOut
--					) - 1 AS Change
--From	@MyTable


--Select datediff(day, '2012-05-01', '2012-09-06')

--Select ', (''' + ItemRef + ''', ''' + Convert(varchar(10), LoanedOut + 128, 120) + ''', ''' + Convert(varchar(10), DueForReturn + 128, 120) + ''')'
--From @MyTable



--('Item1', '2012-05-01', '2012-05-02')
--, ('Item2', '2012-05-03', '2012-05-10')
--, ('Item1', '2012-05-04', '2012-05-10')
--, ('Item2', '2012-05-15', '2012-05-17')
--, ('Item1', '2012-05-11', '2012-05-13')
--, ('Item2', '2012-05-20', '2012-05-22')