Use [TechEdNZ2012]
Go
SELECT	[EmployeeKey]
		, [SalesAmount]
		, Row_Number() Over(Partition By EmployeeKey Order By SalesAmount) As RN
FROM	EmployeeSales
Order by EmployeeKey, SalesAmount;

--Calculating Median Value by using row_Number and count
;With CTE
AS
(
SELECT	[EmployeeKey]
		, [SalesAmount]
		, Row_Number() Over(Partition By EmployeeKey Order By SalesAmount) As RN
		, Count(*) Over(Partition By EmployeeKey) As MyCount
FROM	EmployeeSales
--Order by EmployeeKey, SalesAmount;
)

Select	EmployeeKey, Cast(Avg(1.0 * SalesAmount) as decimal(9,1)) AS Median
From	CTE
Where	RN = (MyCount + 1) / 2
			Or
		RN = (MyCount + 2) / 2
Group By EmployeeKey
Order By EmployeeKey;


--Calculating Median value by using the new distribution function Percentile_Cont
SELECT	[EmployeeKey]
		, [SalesAmount]
		, Percentile_Cont(0.5) Within Group (Order by SalesAmount)
			Over(Partition By EmployeeKey) As Median
		--, Row_Number() Over(Partition By EmployeeKey Order By SalesAmount) As RN
FROM	EmployeeSales;








--SELECT	[EmployeeKey]
--		, [SalesAmount]
--		, Row_Number() Over(Partition By EmployeeKey Order By SalesAmount) As RN
--		, Count(*) Over(Partition By EmployeeKey) 
--			-
--		Row_Number() Over(Partition By EmployeeKey Order By SalesAmount) + 1
--		As RNDesc
--FROM	EmployeeSales
--Order by EmployeeKey, SalesAmount;




--SELECT	[EmployeeKey]
--		, [OrderDateKey]
--		, Cast(Sum([ExtendedAmount]) as int) As SalesAmount
--Into	EmployeeSales
--FROM	[AdventureWorksDW2012].[dbo].[FactResellerSales]
--Where	OrderDateKey > 20061201
--Group By [EmployeeKey], [OrderDateKey]
--Order by [EmployeeKey], SalesAmount;